varying vec4 Color;

uniform float PixelSize;
uniform float FadeWidth; // 0 for nice AA, 1 for very fuzzy line.

void main()
{
	gl_FragColor = Color;
	vec2 tc = gl_TexCoord[0].xy;
	float x = tc.x;
	float width = tc.y;
	
	float fw = max(PixelSize, width*FadeWidth*0.5);
	
	float a = 1.0;
	
	if (x < fw)
		a = x/fw;
		
	if (x > width - fw)
		a = min(a, (width-x)/fw);
		
	// Fade out very thin lines
	if (width < 2.0*PixelSize)
		a *= width/(2.0*PixelSize);
		
	gl_FragColor.a *= a;
}
