uniform sampler2D FieldSampler;
uniform float Cutoff;
uniform vec4 Color;

const float Wiggle = 0.15;

void main()
{
	vec2 tc = gl_TexCoord[0].st;
	vec4 tex = texture2D(FieldSampler, tc);
	
	float meta = tex.b;
	
	float water  = smoothstep(Cutoff-Wiggle, Cutoff+Wiggle, meta);
	gl_FragColor = Color;
	gl_FragColor.a *= water;
	
	float foam = abs(meta-Cutoff) / (Wiggle * 1.0);
	vec3 FoamColor = clamp(8.0 * Color.rgb, 0.0, 1.0);
	if (foam < 1.0)
		//gl_FragColor.rgb = mix(gl_FragColor.rgb, vec3(0.5,0.5,1.0), 1.0-foam);
		gl_FragColor.rgb = mix(Color.rgb, FoamColor, 1.0-foam);
	
	float select = abs(tex.r-Cutoff) / (Wiggle * 2.0);
	if (select < 1.0)
		gl_FragColor = mix(gl_FragColor, vec4(1.0), 1.0-select);
		//gl_FragColor.rgb += vec3(1.0) * (1.0-select); // Pre 1.6.4
}
